if(!org) var org = {};
if(!org.xtc) org.xtc = {};
if(!org.xtc.tp) org.xtc.tp = {};

//Components.utils.import("resource:///modules/searchSpec.js");
//Components.utils.import("resource:///modules/quickFilterManager.js");

org.xtc.tp = function(){
  
  function pub(){};

  const MSG_FLAG_PARTIAL = 0x400;

  var hiddenTPWindow = null;
  var hiddenHdr = null;
  var hiddenURL = null;
  var isPEC = false;
  var hasP7MBug = false;
  var loadingPEC = false;
  var signedValue = "";
  var hiddenSignerCert = null;
  var hiddenEncryptionCert = null;
  var hiddenSignatureStatus = null;
  var hiddenEncryptionStatus = null;
  var hiddenNotificationBar = null;
  var hiddenNBIndex = 0;
  var smimeHdr = null;
  var tpecCS = null;
  var tpecCT = null;
  var hiddenOP = 0;
  var enableTP = false;
  var prefTP = null;
  var tmpDirFile = null;
  var tmpDir = "";
  var removeReply = false;
  var latestEvent = null;
  var needRedirect = false;
  var hFeatures = "chrome,dialog=no,status=no,toolbar=no,width=100,height=0";
  
  pub.jsdump = function(str){
    if(prefTP.getDebug()){
      Components.classes['@mozilla.org/consoleservice;1']
                .getService(Components.interfaces.nsIConsoleService)
                .logStringMessage("ThunderPEC: "+str);
                }
  };

  pub.init = function() {
    
    prefTP = new ThunderPecPrefs();
    prefTP.init();
    
    var dirService = Components.classes["@mozilla.org/file/directory_service;1"]
                           .getService(Components.interfaces.nsIProperties);
    tmpDirFile = dirService.get("TmpD", Components.interfaces.nsIFile);
//    tmpDirFile.append('thunderpec');
    var tstamp = new Date().getTime();
    tmpDirFile.append('tp'+tstamp);
    if( !tmpDirFile.exists() || !tmpDirFile.isDirectory() ) {   
      try {
        tmpDirFile.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0700);  
        org.xtc.tp.jsdump("OK: "+tmpDirFile.path+" directory created"); 
      } catch (e){
        org.xtc.tp.jsdump("KO: error in creating "+tmpDirFile.path+" directory"); 
      }
        
    } else {
//       var files = tmpDirFile.directoryEntries;
//       var file = "";
//       while (files.hasMoreElements()) {  
//         file = files.getNext().QueryInterface(Components.interfaces.nsILocalFile); 
//         file.remove(false);
//       }
     }
    tmpDir = tmpDirFile.path;                   

    tpecCS = Components.classes["@mozilla.org/messengercompose;1"].getService();
    tpecCS = tpecCS.QueryInterface(Components.interfaces.nsIMsgComposeService);
    
    tpecCT = Components.interfaces.nsIMsgCompType;
    
    if(typeof(gMessageListeners) != "undefined") {
      gMessageListeners.push(messageListener);
      org.xtc.tp.jsdump("OK: registering message listener"); 
    } else {
      org.xtc.tp.jsdump("KO: registering message listener"); 
    }
    document.getElementById("tpecToolbox").hidden = true; 


  };
  
  pub.end = function() {
//     var dirService = Components.classes["@mozilla.org/file/directory_service;1"]
//                            .getService(Components.interfaces.nsIProperties);
//     var tmpDirFile = dirService.get("TmpD", Components.interfaces.nsIFile);
//     tmpDirFile.append('thunderpec');
    if( tmpDirFile.exists() && tmpDirFile.isDirectory() ) {   
//       var files = tmpDirFile.directoryEntries;
//       var file = "";
//       while (files.hasMoreElements()) {  
//         file = files.getNext().QueryInterface(Components.interfaces.nsILocalFile); 
//         file.remove(false);
//       }
      tmpDirFile.remove(true);
     }
  };
  
  pub.addAccount = function() {
    var optwin = window.openDialog("chrome://thunderpec/content/accountTP.xul","account","centerscreen, dialog, modal=yes, chrome");
    prefTP.reread();
  };

  pub.selectAccount = function() {
    var optwin = window.openDialog("chrome://thunderpec/content/selectTP.xul","account","centerscreen, dialog, modal=yes, chrome");
    prefTP.reread();
  };

  pub.Enable = function(){
    document.getElementById("replyMainMenu").setAttribute("disabled", "true");
    document.getElementById("replySenderMainMenu").setAttribute("disabled", "true");
  };


  pub.help = function() {
    var optwin = window.openDialog("chrome://thunderpec/content/helpTP.xul","Help","centerscreen, dialog, modal=yes, chrome");
  };

  pub.about = function() {
    var optwin = window.openDialog("chrome://thunderpec/content/aboutTP.xul","About","centerscreen, dialog, modal=yes, chrome");
  };

  pub.support = function() {
    var sURL="mailto:thunderpec@gmail.com?subject=ThunderPEC:";

    var msgComposeService = Components.classes["@mozilla.org/messengercompose;1"]
      .getService(Components.interfaces.nsIMsgComposeService);
    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
      .getService(Components.interfaces.nsIIOService);

    aURI = ioService.newURI(sURL, null, null);
    msgComposeService.OpenComposeWindowWithURI (null, aURI);  
    };



  pub.getFrame = function(win, frameName) {
    for (var j=0; j<win.frames.length; j++) {
      if (win.frames[j].name == frameName) {
        return win.frames[j];
      }
    }
    return null;
  }
  
  pub.handleMsg = function(event,action){
    ThunderPecUtility.jsdump("MSG CMD: "+needRedirect);
    if(!needRedirect){
      if(action=="forward"){
        MsgForwardMessage(event);
      } else if (action=="reply"){
        MsgReplySender(event);      
      } else if (action=="replyall"){
        MsgReplyToAllMessage(event);      
      } 
      return;
    }
    needRedirect = false;
    hiddenURL = ThunderPecUtility.saveEML(tmpDir);
    ThunderPecUtility.jsdump("MSG CMD: "+hiddenURL.spec);
    let folder = gFolderDisplay ? GetFirstSelectedMsgFolder() : null;
    var server = folder.server;
    var identity = getIdentityForServer(server);

    var type = "";
    if(action=="forward"){
      type = tpecCT.ForwardInline;
    } else if (action=="reply"){
      type = tpecCT.Reply;      
    } else if (action=="replyall"){
      type = tpecCT.ReplyAll;      
    }
    var hdr = messenger.msgHdrFromURI(hiddenURL.spec);
    messenger.setWindow(window, msgWindow);
   
    if(tpecCS){
      var msgComposeService = Components.classes["@mozilla.org/messengercompose;1"]
        .getService(Components.interfaces.nsIMsgComposeService);
      msgComposeService.OpenComposeWindow( null, hdr,hiddenURL.spec, type, 0, identity, msgWindow);
    }
  }

  pub.handleButton = function(action){
    hiddenURL = ThunderPecUtility.saveEML(tmpDir);
    let folder = gFolderDisplay ? GetFirstSelectedMsgFolder() : null;
    var server = folder.server;
    var identity = getIdentityForServer(server);

    var type = "";
    if(action=="forward"){
      type = tpecCT.ForwardInline;
    } else if (action=="reply"){
      type = tpecCT.Reply;      
    } else if (action=="replyall"){
      type = tpecCT.ReplyAll;      
    }
    var hdr = messenger.msgHdrFromURI(hiddenURL.spec);
    messenger.setWindow(window, msgWindow);
   
    if(tpecCS){
      var msgComposeService = Components.classes["@mozilla.org/messengercompose;1"]
        .getService(Components.interfaces.nsIMsgComposeService);
      msgComposeService.OpenComposeWindow( null, hdr,hiddenURL.spec, type, 0, identity, msgWindow);
    }
  }

  pub.handlePrintButton = function(action){
    hiddenURL = ThunderPecUtility.saveEML(tmpDir);
    var tpMessageList = new Array();
    tpMessageList.push(hiddenURL.spec);
    var tpStatusFeedback = Components.classes["@mozilla.org/messenger/statusfeedback;1"]
                        .createInstance(Components.interfaces.nsIMsgStatusFeedback);
    tpStatusFeedback.setWrappedStatusFeedback(window.MsgStatusFeedback);
    var doPrintPreview = false;
    var msgType = Components.interfaces.nsIMsgPrintEngine.MNAB_PRINT_MSG;
    if(action=="printpreview"){
      doPrintPreview = true;
      msgType = Components.interfaces.nsIMsgPrintEngine.MNAB_PRINTPREVIEW_MSG
    }
    window.openDialog("chrome://messenger/content/msgPrintEngine.xul", "",
                      "chrome,dialog=no,all,centerscreen",
                      tpMessageList.length, tpMessageList, tpStatusFeedback,
                      doPrintPreview, msgType, window);
  }     

  pub.receiptButton = function(action){
    var folder = gFolderDisplay.displayedFolder;
    if(folder){
      while(folder.parent!=null){
        folder = folder.parent;
      }
      var mbxName = folder.name;
      var addresses = "";
      if(gFolderDisplay.selectedMessage){
        addresses = gFolderDisplay.selectedMessage.ccList+","+gFolderDisplay.selectedMessage.recipients;
      }

//      if(prefTP.exists(mbxName)){
      if(prefTP.check(addresses)){
        if(gFolderDisplay.selectedMessage){
          var subject = gFolderDisplay.selectedMessage.subject;
          if(subject.indexOf("POSTA CERTIFICATA")>=0 || subject.indexOf("ANOMALIA MESSAGGIO")>=0){
            hiddenURL = ThunderPecUtility.getXML(tmpDir);
            if(hiddenURL!=null){
              var optwin = window.openDialog("chrome://thunderpec/content/xmlTP.xul","","centerscreen, dialog, modal=yes, chrome",{xml:hiddenURL,dir:tmpDir});
            }
          } else {
            hiddenURL = ThunderPecUtility.getXML(tmpDir);
            if(hiddenURL!=null){
              var optwin = window.openDialog("chrome://thunderpec/content/xmlTP.xul","","centerscreen, dialog, modal=yes, chrome",{xml:hiddenURL,dir:tmpDir});
            }
          }
        }
      }
    }
  }  

  pub.envelopeButton = function(action){
    var folder = gFolderDisplay.displayedFolder;
    var envelopeTXT = "";
    if(folder){
      while(folder.parent!=null){
        folder = folder.parent;
      }
      var mbxName = folder.name;
      var addresses = "";
      if(gFolderDisplay.selectedMessage){
        addresses = gFolderDisplay.selectedMessage.ccList+","+gFolderDisplay.selectedMessage.recipients;
      }

//      if(prefTP.exists(mbxName)){
      if(prefTP.check(addresses)){
        if(gFolderDisplay.selectedMessage){
          var subject = gFolderDisplay.selectedMessage.subject;
          envelopeTXT = ThunderPecUtility.getTxt(tmpDir);
          var optwin = window.openDialog("chrome://thunderpec/content/certTP.xul","","centerscreen, dialog, modal=yes, chrome",{cert:envelopeTXT,dir:tmpDir});
          }
        }
      }
    }

  pub.handlePrint = function(event,action){
    if(!needRedirect){
      if(action=="printpreview"){
        PrintEnginePrintPreview(event);
      } else if (action=="print"){
        PrintEnginePrint(event);      
      } 
      return;
    }
    needRedirect = false;
    hiddenURL = ThunderPecUtility.saveEML(tmpDir);
    ThunderPecUtility.jsdump("PRINT CMD: "+hiddenURL);
    var tpMessageList = new Array();
    tpMessageList.push(hiddenURL.spec);
    var tpStatusFeedback = Components.classes["@mozilla.org/messenger/statusfeedback;1"]
                        .createInstance(Components.interfaces.nsIMsgStatusFeedback);
    tpStatusFeedback.setWrappedStatusFeedback(window.MsgStatusFeedback);
    var doPrintPreview = false;
    var msgType = Components.interfaces.nsIMsgPrintEngine.MNAB_PRINT_MSG;
    if(action=="printpreview"){
      doPrintPreview = true;
      msgType = Components.interfaces.nsIMsgPrintEngine.MNAB_PRINTPREVIEW_MSG
    }
    window.openDialog("chrome://messenger/content/msgPrintEngine.xul", "",
                      "chrome,dialog=no,all,centerscreen",
                      tpMessageList.length, tpMessageList, tpStatusFeedback,
                      doPrintPreview, msgType, window);
  }     


  pub.handleLoadEvent = function(event){
    var chkHeaders = false;
    var folder = gFolderDisplay.displayedFolder;    
    var msgWindow = Components.classes["@mozilla.org/messenger/msgwindow;1"]
                      .createInstance(Components.interfaces.nsIMsgWindow);
    var notificationBar;
    
    if(!loadingPEC){
      isPEC = false;
      hiddenHdr = null;
      loadingPEC = true;
      hasP7MBug = false;
      if(folder){
        while(folder.parent!=null){
          folder = folder.parent;
        }
        var mbxName = folder.name;
        var subject = currentHeaderData.subject.headerValue;
        removeReply = false;
        if(gFolderDisplay.selectedMessageUris[0]){
          var tmpHdr = messenger.msgHdrFromURI(gFolderDisplay.selectedMessageUris[0]);
          if(tmpHdr.flags & MSG_FLAG_PARTIAL){
            org.xtc.tp.jsdump("partial");
          }
        }
        
//        if(prefTP.exists(mbxName) && utilityTP.check()==true){
        chkHeaders = ThunderPecUtility.check(tmpDir);
        if(prefTP.check(tmpHdr.ccList+","+tmpHdr.recipients) && chkHeaders==true){
          isPEC = true;
          signedValue = document.getElementById("signedHdrIcon").getAttribute("signed");
          hiddenSignerCert = gSignerCert;   
          hiddenEncryptionCert = gEncryptionCert;
          hiddenSignatureStatus = gSignatureStatus;
          hiddenEncryptionStatus = gEncryptionStatus;
          notificationBar = document.getElementById("msgNotificationBar");
          hiddenNotificationBar = notificationBar.getAttribute("collapsed");
          hiddenNBIndex = notificationBar.getAttribute("selectedIndex");
          org.xtc.tp.jsdump("OK: signature status "+ signedValue);
          if(subject.indexOf("POSTA CERTIFICATA")>=0 || subject.indexOf("ANOMALIA MESSAGGIO")>=0){
            //document.getElementById("tpecToolbox").hidden = false;
            var URL = ThunderPecUtility.saveEML(tmpDir);
            org.xtc.tp.handleToolbar(true,ThunderPecUtility.checkXML(tmpDir));
            if (URL!=null){
             messenger.openURL(URL.spec);
             hiddenHdr = messenger.msgHdrFromURI(URL.spec);
            }
          } else {
            //document.getElementById("tpecToolbox").hidden = true;
            org.xtc.tp.handleToolbar(false,ThunderPecUtility.checkXML(tmpDir));
            org.xtc.tp.hideReply();
            removeReply = true;
            loadingPEC = false;
          }
        } else {
          document.getElementById("header-view-toolbox").hidden = false;    
          document.getElementById("tpecToolbox").hidden = true; 
          isPEC = false;
          loadingPEC = false;   
          if(ThunderPecUtility.hasP7MBug){
            hasP7MBug = chkHeaders;
            signedValue = document.getElementById("signedHdrIcon").getAttribute("signed");
            hiddenSignerCert = gSignerCert;   
            hiddenEncryptionCert = gEncryptionCert;
            hiddenSignatureStatus = gSignatureStatus;
            hiddenEncryptionStatus = gEncryptionStatus;
            notificationBar = document.getElementById("msgNotificationBar");
            hiddenNotificationBar = notificationBar.getAttribute("collapsed");
            hiddenNBIndex = notificationBar.getAttribute("selectedIndex");
              
            var URL = ThunderPecUtility.saveP7M(tmpDir);
            if (URL!=null){
             messenger.openURL(URL.spec);
             loadingPEC = true;
            }
          }
        }
      }
    } else {
      if(isPEC){
        org.xtc.tp.hideReply();
        document.getElementById("smimeBox").collapsed = false;    
        document.getElementById("signedHdrIcon").collapsed = false;   
        document.getElementById("signedHdrIcon").setAttribute("signed",signedValue);
        signedValue = ""; 
        gSignerCert = hiddenSignerCert;   
        gEncryptionCert = hiddenEncryptionCert;
        gSignatureStatus = hiddenSignatureStatus;
        gEncryptionStatus = hiddenEncryptionStatus;
        notificationBar = document.getElementById("msgNotificationBar");
        notificationBar.setAttribute("collapsed",hiddenNotificationBar);
        notificationBar.setAttribute("selectedIndex",hiddenNBIndex);
        hiddenSignerCert = null;
        hiddenEncryptionCert = null;
        hiddenSignatureStatus = null;
        hiddenEncryptionStatus = null;
        hiddenNotificationBar = null;
        hiddenNBIndex = null;
      } else {
        if(hasP7MBug==true){
          document.getElementById("smimeBox").collapsed = false;    
          document.getElementById("signedHdrIcon").collapsed = false;   
          document.getElementById("signedHdrIcon").setAttribute("signed",signedValue);
          signedValue = ""; 
          gSignerCert = hiddenSignerCert;   
          gEncryptionCert = hiddenEncryptionCert;
          gSignatureStatus = hiddenSignatureStatus;
          gEncryptionStatus = hiddenEncryptionStatus;
          notificationBar = document.getElementById("msgNotificationBar");
          notificationBar.setAttribute("collapsed",hiddenNotificationBar);
          notificationBar.setAttribute("selectedIndex",hiddenNBIndex);
          hiddenSignerCert = null;
          hiddenEncryptionCert = null;
          hiddenSignatureStatus = null;
          hiddenEncryptionStatus = null;
          hiddenNotificationBar = null;
          hiddenNBIndex = null;
        } 
        var MessageURI = gFolderDisplay.selectedMessageUris[0];
        var msgHdr = messenger.messageServiceFromURI(MessageURI).messageURIToMsgHdr(MessageURI);
        msgHdr.markRead(true);
      }
      isPEC = false;
      loadingPEC = false;
      hasP7MBug = false;
    }
  }

  pub.mainMenu = function(){
    var folder = gFolderDisplay.displayedFolder;
    if(folder){
      while(folder.parent!=null){
        folder = folder.parent;
      }
      var mbxName = folder.name;

      var mainMenu = document.getElementById("messageMenuPopup");
      if(mainMenu){
        var firstChild = mainMenu.firstChild;
        if(firstChild.getAttribute('id')!="tpecMenu") {
          var separator = document.createElement("menuseparator");
          mainMenu.insertBefore(separator,firstChild);
          firstChild = mainMenu.firstChild;
          mainMenu.insertBefore(document.getElementById("tpecMenu"),firstChild);
        }
      }
      
      var addresses = "";
      if(gFolderDisplay.selectedMessage){
        addresses = gFolderDisplay.selectedMessage.ccList+","+gFolderDisplay.selectedMessage.recipients;

//      if(prefTP.exists(mbxName) && utilityTP.check()==true){
        if(prefTP.check(addresses) && ThunderPecUtility.check(tmpDir)==true){
          if(gFolderDisplay.selectedMessage){
            var subject = gFolderDisplay.selectedMessage.subject;
            removeReply = true;
            needRedirect = false;
            document.getElementById("tpecMenu").setAttribute("disabled", "false");
            if(subject.indexOf("POSTA CERTIFICATA")>=0 || subject.indexOf("ANOMALIA MESSAGGIO")>=0){
              removeReply = false;
              needRedirect = true;
              document.getElementById("tpecMenuReply").setAttribute("disabled", "false");
              if(org.xtc.tp.checkReplyAll(messageHeaderSink.mSaveHdr)){
                document.getElementById("tpecMenuReplyAll").disabled = false;
              } else {
                document.getElementById("tpecMenuReplyAll").disabled = true;
              }
            }
            if(removeReply){
              document.getElementById("tpecMenuReply").setAttribute("disabled", "true");
              document.getElementById("tpecMenuReplyAll").setAttribute("disabled", "true");
            }
          } 
        } else {
            document.getElementById("tpecMenu").setAttribute("disabled", "true");
        }
      }
    }
  }

 
  pub.contextMenu = function(){
    var folder = gFolderDisplay.displayedFolder;
    if(folder){
      while(folder.parent!=null){
        folder = folder.parent;
      }
      var mbxName = folder.name;

      var contextMenu = document.getElementById("mailContext");
      if(contextMenu){
        var firstChild = contextMenu.firstChild;
        if(firstChild.getAttribute('id')!="tpecContext") {
          var separator = document.createElement("menuseparator");
          contextMenu.insertBefore(separator,firstChild);
          firstChild = contextMenu.firstChild;
          contextMenu.insertBefore(document.getElementById("tpecContext"),firstChild);
        }
      }
      var addresses = "";
      var tmpMessage = gFolderDisplay.selectedMessage;
      if(tmpMessage){
        addresses = tmpMessage.ccList+","+tmpMessage.recipients;
//      if(prefTP.exists(mbxName) && 3ThunderPecUtility.check()==true){
        document.getElementById("tpecContext").setAttribute("disabled", "true");
        var chkHeaders =  ThunderPecUtility.check(tmpDir);
        document.getElementById("tpecContext").setAttribute("disabled", "false");
        if(prefTP.check(addresses) && chkHeaders==true){
          var subject = tmpMessage.subject;
          removeReply = true;
          needRedirect = false;
          document.getElementById("tpecContext").setAttribute("disabled", "false");
          if(subject.indexOf("POSTA CERTIFICATA")>=0 || subject.indexOf("ANOMALIA MESSAGGIO")>=0){
            removeReply = false;
            needRedirect = true;
            document.getElementById("tpecContextReply").setAttribute("disabled", "false");
            if(org.xtc.tp.checkReplyAll(messageHeaderSink.mSaveHdr)){
              document.getElementById("tpecContextReplyAll").disabled = false;
            } else {
              document.getElementById("tpecContextReplyAll").disabled = true;
            }
          }
          if(removeReply){
            document.getElementById("tpecContextReply").setAttribute("disabled", "true");
            document.getElementById("tpecContextReplyAll").setAttribute("disabled", "true");
          }
        } else {
            document.getElementById("tpecContext").setAttribute("disabled", "true");
        }
      }
    }
  }


  var messageListener = {
    smime:null,
    element:null,
    
    onStartHeaders: function() {
    },
    onBeforeShowHeaderPane: function() {
    },
    onEndHeaders: function() {
      var msgFrame = org.xtc.tp.getFrame(window,"messagepane");
      msgFrame.addEventListener("load", org.xtc.tp.handleLoadEvent, false);
    },
    onEndAttachments: function() {
      if(isPEC && !document.getElementById("tpecToolbox").hidden){
        if(org.xtc.tp.checkReplyAll(messageHeaderSink.mSaveHdr)){
          document.getElementById("tpecReplyAllButton").hidden = false;
        } else {
          document.getElementById("tpecReplyAllButton").hidden = true;
        }
      }
    }
  };                  

  pub.hideReply = function(){
    if(document.getElementById("hdrReplyButton")!=null){
      document.getElementById("hdrReplyButton").hidden = true;
      }
    if(document.getElementById("hdrReplyAllButton")!=null){
      document.getElementById("hdrReplyAllButton").hidden = true;
      }
    if(document.getElementById("hdrReplyAllSubButton")!=null){
      document.getElementById("hdrReplyAllSubButton").hidden = true;
      }
    if(document.getElementById("hdrReplyAllSubButtonSep")!=null){
      document.getElementById("hdrReplyAllSubButtonSep").hidden = true;
      }
    if(document.getElementById("hdrReplyListButton")!=null){
      document.getElementById("hdrReplyListButton").hidden = true;  
      }
    if(document.getElementById("hdrReplyToSenderButton")!=null){
      document.getElementById("hdrReplyToSenderButton").hidden = true;
      }
  };      
  
  pub.handleToolbar= function(b,x){
    document.getElementById("tpecToolbox").hidden = false;    
    if(b){
      document.getElementById("tpecSearchButton").hidden = true;
      document.getElementById("tpecReceiptButton").hidden = !x;
      document.getElementById("tpecForwardButton").hidden = false;
      document.getElementById("tpecReplyButton").hidden = false;
      document.getElementById("tpecReplyAllButton").hidden = false;
      document.getElementById("tpecPrintButton").hidden = false;
    } else {
      document.getElementById("tpecSearchButton").hidden = !x;
      document.getElementById("tpecReceiptButton").hidden = !x;
      document.getElementById("tpecForwardButton").hidden = true;
      document.getElementById("tpecReplyButton").hidden = true;
      document.getElementById("tpecReplyAllButton").hidden = true;
      document.getElementById("tpecPrintButton").hidden = true;
      if(!x){
        document.getElementById("tpecToolbox").hidden = true;
      }
    }
  }            

  pub.checkReplyAll = function(hdr){
    var numAddresses = 1;
    var imInAddresses = false;
    if(hdr){
      var folder = gFolderDisplay ? GetFirstSelectedMsgFolder() : null;
      var server = folder.server;
      var addresses = hdr.author + "," + hdr.recipients + "," + hdr.ccList;
      var identity = getIdentityForServer(server);
      if(identity){
        var myEmail = identity.email;
        imInAddresses = myEmail && (addresses.toLowerCase().indexOf(myEmail.toLowerCase()) != -1);
      }
      var hdrParser = Components.classes["@mozilla.org/messenger/headerparser;1"]
                          .getService(Components.interfaces.nsIMsgHeaderParser);
      var uniqueAddresses = hdrParser.removeDuplicateAddresses(addresses, "");
      var emailAddresses = {};
      numAddresses = hdrParser.parseHeadersWithArray(uniqueAddresses,
                            emailAddresses, {}, {});
      for (var i in emailAddresses.value)
      {
        if (/:/.test(emailAddresses.value[i]))
          numAddresses--;
        if (emailAddresses.value[i]=="null")
          numAddresses--;
      }
      if (imInAddresses)
        numAddresses--;
      }
    return numAddresses > 1;
  };                  

    pub.receiptMenu = function(){
      var receipt = prefTP.getReceipt();
      var menuC = document.getElementById("tpecComplete");
      var menuB = document.getElementById("tpecBrief");
      var menuS = document.getElementById("tpecSynth");
      
      menuC.setAttribute("checked", false);
      menuB.setAttribute("checked", false);
      menuS.setAttribute("checked", false);
      
      if(receipt=="completa")menuC.setAttribute("checked", true);
      if(receipt=="breve")menuB.setAttribute("checked", true);
      if(receipt=="sintetica")menuS.setAttribute("checked", true);
    };

    pub.setP7MStatus = function(r){
      prefTP.setP7M(r);
    };

    pub.p7mMenu = function(){
      var p7m = prefTP.getP7M();
      var menuC = document.getElementById("tpecP7MOn");
      var menuB = document.getElementById("tpecP7MOff");
      
      menuC.setAttribute("checked", false);
      menuB.setAttribute("checked", false);
      
      if(p7m=="on")menuC.setAttribute("checked", true);
      if(p7m=="off")menuB.setAttribute("checked", true);
    };

    pub.setP7MStatus = function(r){
      prefTP.setP7M(r);
    };

    pub.getP7MStatus = function(){
      return prefTP.getP7M();
    };
    
    pub.getDebug = function(){
      return prefTP.getDebug();
    };


    pub.findAccountFromIdentity = function(id) {
        if (!id)
            return null;
        var acctMgr = Components.classes["@mozilla.org/messenger/account-manager;1"]
            .getService(Components.interfaces.nsIMsgAccountManager);
        var accounts = acctMgr.accounts;
        for (var i = 0; i < accounts.Count(); i++) {
            var account = accounts.QueryElementAt(i, Components.interfaces.nsIMsgAccount);
            if(account.defaultIdentity == id)
                return account.QueryInterface(Components.interfaces.nsIMsgAccount);
            var identities = account.identities;
            for(var j=0;j<identities.Count();j++){
              var ids = identities.QueryElementAt(j, Components.interfaces.nsIMsgIdentity);
              if(ids == id)
                  return account.QueryInterface(Components.interfaces.nsIMsgAccount);
            }             
        }
        return null;
    };
    
    pub.searchButton = function () {
      var addresses = "";
      if(gFolderDisplay.selectedMessage){
        var msg = gFolderDisplay.selectedMessage;
        addresses = gFolderDisplay.selectedMessage.ccList+","+gFolderDisplay.selectedMessage.recipients;
      }
      var account = org.xtc.tp.findAccountFromIdentity(getIdentityForHeader(msg));
      if(account){
        org.xtc.tp.jsdump("seachTP: account OK");
        var folder = account.incomingServer.rootFolder;
        if(folder){
          org.xtc.tp.jsdump("seachTP: folder OK");
          while(folder.parent!=null){
            folder = folder.parent;
          }
          var mbxName = folder.name;
  
    //      if(prefTP.exists(mbxName)){
          if(prefTP.check(addresses)){
            if(gFolderDisplay.selectedMessage){
              var subject = gFolderDisplay.selectedMessage.subject;
              if(subject.indexOf("POSTA CERTIFICATA")==-1 && subject.indexOf("ANOMALIA MESSAGGIO")==-1){
                hiddenURL = ThunderPecUtility.getXML(tmpDir);
                if(hiddenURL!=null){
                  var optwin = window.openDialog("chrome://thunderpec/content/searchTP.xul","","centerscreen, dialog, modal=yes, chrome",{xml:hiddenURL,dir:tmpDir,fld:folder});
                }
  
              }
            }
          }
        }
      } else {
        org.xtc.tp.jsdump("seachTP: account KO");      
      }
    };

    pub.searchPA = function() {
      window.openDialog("chrome://thunderpec/content/spcdataTP.xul","","centerscreen, dialog, modal=yes, chrome",{from:"main",win:this});
    }

  return pub;
}();


