function ThunderPecPrefs(){
  this.prefsTP = null;
  this.prefService = null;
  this.pecAccounts = "";
  this.pecReceipt = "";
  this.p7m = "";
  this.debug = "";
  this.pecArray = null;
  this.version ="1.3.3";
  
  this.init = function() {
    this.prefsTP = Components.classes["@mozilla.org/preferences-service;1"].
                        getService(Components.interfaces.nsIPrefBranch);
    this.prefService = Components.classes["@mozilla.org/preferences-service;1"].
                        getService(Components.interfaces.nsIPrefService);

    try {
      this.pecAccounts = this.prefsTP.getCharPref("thunderpec.accounts");
    } catch (e){
      this.prefsTP.setCharPref("thunderpec.accounts","");
      this.prefService.savePrefFile(null);

    }
    try {
      this.pecReceipt = this.prefsTP.getCharPref("thunderpec.receipt");
    } catch (e){
      this.prefsTP.setCharPref("thunderpec.receipt","completa");
      this.pecReceipt = "completa";
      this.prefService.savePrefFile(null);

    }

    try {
      this.p7m = this.prefsTP.getCharPref("thunderpec.p7m");
    } catch (e){
      this.prefsTP.setCharPref("thunderpec.p7m","on");
      this.p7m = "on";
      this.prefService.savePrefFile(null);

    }

    try {
      this.debug = this.prefsTP.getCharPref("thunderpec.debug");
    } catch (e){
      this.prefsTP.setCharPref("thunderpec.debug","off");
      this.p7m = "off";
      this.prefService.savePrefFile(null);

    }

    var previousVersion;
    try {
      previousVersion = this.prefsTP.getCharPref("thunderpec.version");
    } catch (e){
      previousVersion = "";
      this.prefsTP.setCharPref("thunderpec.version",this.version);
      this.prefService.savePrefFile(null);
    }
    
    if(previousVersion!=this.version){
      this.showUpdate();
      this.prefsTP.setCharPref("thunderpec.version",this.version);
      this.prefService.savePrefFile(null);
    }
    
    this.pecArray = this.pecAccounts.split(",");
  }
  
  this.exists = function(m){
    if(this.pecArray)
      for (var i=0; i<this.pecArray.length; i++)
        if (this.pecArray[i] == m) return true;
    return false;
  }

  this.check = function(m){
    if(this.pecArray)
      for (var i=0; i<this.pecArray.length; i++)
        if ((this.pecArray[i]!="") && (m.toLowerCase().indexOf(this.pecArray[i],0)!=-1)) return true;
    return false;
  }

  this.reread = function() {
    this.pecAccounts = this.prefsTP.getCharPref("thunderpec.accounts");
    this.pecArray = this.pecAccounts.split(",");
  }

  this.clear = function() {
    this.pecAccounts = "";
    this.pecArray = Array();
    this.prefsTP.setCharPref("thunderpec.accounts",this.pecAccounts);
    this.prefService.savePrefFile(null);
  }

  
  this.getAccounts = function(){
    return this.pecAccounts;
  }
  
  this.addAccount = function(a){
    if(!this.exists(a)){
      this.pecArray.push(a);
      this.pecAccounts = this.pecArray.join(",");
      this.prefsTP.setCharPref("thunderpec.accounts",this.pecAccounts);
      this.prefService.savePrefFile(null);
      }
  }

  this.getReceipt = function(){
    return this.pecReceipt;
  }

  this.setReceipt = function(r){
    this.prefsTP.setCharPref("thunderpec.receipt",r);
    this.prefService.savePrefFile(null);
    this.pecReceipt = r;
  }

  this.getP7M = function(){
    return this.p7m;
  }

  this.setP7M = function(r){
    this.prefsTP.setCharPref("thunderpec.p7m",r);
    this.prefService.savePrefFile(null);
    this.p7m = r;
  }

  this.getDebug = function(){
    return this.debug=="on";
  }

  this.getVersion = function(){
    return this.version;
  }

  this.showUpdate = function(){
    
    let url = "http://www.pocketpec.it/thunderbird/?c=cronologia130";
    let tabmail = document.getElementById("tabmail");
    if (!tabmail) {
      // Try opening new tabs in an existing 3pane window
      let mail3PaneWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                                      .getService(Components.interfaces.nsIWindowMediator)
                                      .getMostRecentWindow("mail:3pane");
      if (mail3PaneWindow) {
        tabmail = mail3PaneWindow.document.getElementById("tabmail");
        mail3PaneWindow.focus();
      }
    }
    
    if (tabmail)
      tabmail.openTab("contentTab", {contentPage: url});
    else
      window.openDialog("chrome://messenger/content/", "_blank",
                        "chrome,dialog=no,all", null,
                        { tabType: "contentTab",
                          tabParams: {contentPage: url} }); 
  }
}
