if(!org) var org = {};
if(!org.xtc) org.xtc = {};
if(!org.xtc.tp) org.xtc.tp = {};
if(!org.xtc.tp.qfb) org.xtc.tp.qfb = {};

Components.utils.import("resource:///modules/searchSpec.js");
Components.utils.import("resource:///modules/quickFilterManager.js");


org.xtc.tp.qfb = function(){
  function pub(){};

  var qfb_listener = {
    _init: function(){
      FolderDisplayListenerManager.registerListener(this);
    },
    onMakeActive: function(aFolderDisplay) {
      var folder = gFolderDisplay.displayedFolder;
      org.xtc.tp.qfb.jsdump("QFB: folder: "+folder.name); 
      var account = org.xtc.tp.qfb.findAccountFromFolder(folder);
      if(account) {
        var mbxName = "     ";
        if(account.defaultIdentity){
          mbxName = account.defaultIdentity.email;
        }
//      if(folder){
//        while(folder.parent!=null){
//          folder = folder.parent;
//        }
//        var mbxName = folder.name;
        org.xtc.tp.qfb.jsdump("QFB: mbxname: "+mbxName);      
        if(prefTP.exists(mbxName)){
          org.xtc.tp.qfb.jsdump("QFB: activate toolbar");      
          document.getElementById("tpec-qfb-messages").setAttribute("disabled", "false");
          document.getElementById("tpec-qfb-notifications").setAttribute("disabled", "false");
        } else {
          org.xtc.tp.qfb.jsdump("QFB: deactivate toolbar");      
          document.getElementById("tpec-qfb-messages").setAttribute("disabled", "true");
          document.getElementById("tpec-qfb-notifications").setAttribute("disabled", "true");
        }
      } else {
        org.xtc.tp.qfb.jsdump("QFB: account not found; deactivate toolbar");      
        document.getElementById("tpec-qfb-messages").setAttribute("disabled", "true");
        document.getElementById("tpec-qfb-notifications").setAttribute("disabled", "true");
      }
    }   
  };
  
  var prefTP;

  pub.jsdump = function(str){
    if(prefTP.getDebug()){
      Components.classes['@mozilla.org/consoleservice;1']
                .getService(Components.interfaces.nsIConsoleService)
                .logStringMessage("ThunderPEC: "+str);
                }
  };

  pub.init = function(){
    prefTP = new ThunderPecPrefs();
    prefTP.init();
    QuickFilterManager.defineFilter({
      name: "pecmessages",
      domId: "tpec-qfb-messages",
      appendTerms: function(aTermCreator, aTerms, aFilterValue) {
        let term, value;
        term = aTermCreator.createTerm();
        term.attrib = nsMsgSearchAttrib.Subject;
        value = term.value;
        value.str = "POSTA CERTIFICATA";
        term.value = value;
        term.op = nsMsgSearchOp.BeginsWith;
        term.booleanAnd = false;
        aTerms.push(term);
        term = aTermCreator.createTerm();
        term.attrib = nsMsgSearchAttrib.Subject;
        value = term.value;
        value.str = "ANOMALIA MESSAGGIO";
        term.value = value;
        term.op = nsMsgSearchOp.BeginsWith;
        term.booleanAnd = false;
        aTerms.push(term);
      },
    });

    QuickFilterManager.defineFilter({
      name: "pecnotifications",
      domId: "tpec-qfb-notifications",
      appendTerms: function(aTermCreator, aTerms, aFilterValue) {
        let term, value;
        term = aTermCreator.createTerm();
        term.attrib = nsMsgSearchAttrib.Subject;
        value = term.value;
        value.str = "POSTA CERTIFICATA";
        term.value = value;
        term.op = nsMsgSearchOp.DoesntContain;
        term.booleanAnd = true;
        aTerms.push(term);
        term = aTermCreator.createTerm();
        term.attrib = nsMsgSearchAttrib.Subject;
        value = term.value;
        value.str = "ANOMALIA MESSAGGIO";
        term.value = value;
        term.op = nsMsgSearchOp.DoesntContain;
        term.booleanAnd = true;
        aTerms.push(term);
      },
    });
    document.getElementById("tpec-qfb-messages").setAttribute("checked", "false");
    document.getElementById("tpec-qfb-notifications").setAttribute("checked", "false");
    //to solve a problem in tb on linux
    //document.getElementById("quick-filter-bar-collapsible-buttons").setAttribute("shrink", "false");
    qfb_listener._init();
  }

  pub.selectMessages = function(){
      aNode = document.getElementById("tpec-qfb-messages");    
      bNode = document.getElementById("tpec-qfb-notifications");    
      bNode.checked = false;
      try {
        let postValue = aNode.checked ? true : null;
        QuickFilterBarMuxer.activeFilterer.setFilterValue(
          "pecmessages", postValue);
        QuickFilterBarMuxer.deferredUpdateSearch();
      }
      catch (ex) {
        logException(ex);
      }
      try {
        let postValue = bNode.checked ? true : null;
        QuickFilterBarMuxer.activeFilterer.setFilterValue(
          "pecnotifications", postValue);
        QuickFilterBarMuxer.deferredUpdateSearch();
      }
      catch (ex) {
        logException(ex);
      }
  }

  pub.selectNotifications = function(){
      aNode = document.getElementById("tpec-qfb-notifications");    
      bNode = document.getElementById("tpec-qfb-messages");    
      bNode.checked = false;
      try {
        let postValue = aNode.checked ? true : null;
        QuickFilterBarMuxer.activeFilterer.setFilterValue(
          "pecnotifications", postValue);
        QuickFilterBarMuxer.deferredUpdateSearch();
      }
      catch (ex) {
        logException(ex);
      }
      try {
        let postValue = bNode.checked ? true : null;
        QuickFilterBarMuxer.activeFilterer.setFilterValue(
          "pecmessages", postValue);
        QuickFilterBarMuxer.deferredUpdateSearch();
      }
      catch (ex) {
        logException(ex);
      }
  }
  
  pub.findAccountFromFolder = function(theFolder) {
      if (!theFolder)
          return null;
      var acctMgr = Components.classes["@mozilla.org/messenger/account-manager;1"]
          .getService(Components.interfaces.nsIMsgAccountManager);
      var accounts = acctMgr.accounts;
      for (var i = 0; i < accounts.Count(); i++) {
          var account = accounts.QueryElementAt(i, Components.interfaces.nsIMsgAccount);
          var rootFolder = account.incomingServer.rootFolder; // nsIMsgFolder
          if (rootFolder.hasSubFolders) {
              var subFolders = rootFolder.subFolders; // nsIMsgFolder
              while(subFolders.hasMoreElements()) {
                  if (theFolder == subFolders.getNext().QueryInterface(Components.interfaces.nsIMsgFolder))
                      return account.QueryInterface(Components.interfaces.nsIMsgAccount);
              }
          }
      }
      return null;
  }    
  return pub;
}();
