const PR_RDONLY      = 0x01;
const PR_WRONLY      = 0x02;
const PR_RDWR        = 0x04;
const PR_CREATE_FILE = 0x08;
const PR_APPEND      = 0x10;
const PR_TRUNCATE    = 0x20;
const PR_SYNC        = 0x40;
const PR_EXCL        = 0x80;

if(!org) var org = {};
if(!org.xtc) org.xtc = {};
if(!org.xtc.tp) org.xtc.tp = {};
if(!org.xtc.tp.search) org.xtc.tp.search = {};

Components.utils.import("resource:///modules/gloda/mimemsg.js");
Components.utils.import("resource:///modules/gloda/connotent.js");

org.xtc.tp.search = function(){
  function pub(){};

  var xmlReader = Components.classes["@mozilla.org/saxparser/xmlreader;1"]
                        .createInstance(Components.interfaces.nsISAXXMLReader);
  var xmlDoc = "";
  var msgHdr = null;
  var tmpDir = "";
  var htmlDoc = "";
  var attrs = null;
  var attrsArray = null;
  var zone = "";
  var currentView="";
  var folder = null;
  var msgId = null;
  var rifMsgId = null;
  var getChar = false;
  var getValue = "";
  var dstAddr = 0;
  
  var searchSession = null;
  var searchPrefs = null;
  var searchCycle = 0;
  var tpecArrayHdrs = ["message-id", "X-Riferimento-Message-ID","X-Ricevuta"];
  var tpecFirstHeader = Components.interfaces.nsMsgSearchAttrib.OtherHeader + 1;
  var tpecContains = Components.interfaces.nsMsgSearchOp.Contains;
  
  var tpecSentHdr = null;
  var xmlSentHdr = new Array();
  var tpecNotificationsHdr = new Array();
  var tpecIdx = 0;
  
  var sentMeta = null;
  var sentSnippet = null;
  var sentAttachments = null;
  
  var messenger;
  
  var dstAttribute = null;
  var msgAttribute = null;
  
  var showLegend = false;
  
  var prefTP;
  
  var char12;
  var char10;   
  
  var originalMsgId;

  var translateStatus = new Array();
  translateStatus["accettazione"] = "A";
  translateStatus["non-accettazione"] = "NA";
  translateStatus["presa-in-carico"] = "PI";
  translateStatus["avvenuta-consegna"] = "AC";
  translateStatus["posta-certificata"] = "PEC";
  translateStatus["errore-consegna"] = "EC";
  translateStatus["preavviso-errore-consegna"] = "PE";
  translateStatus["rilevazione-virus"] = "RV";
  
  var clearStatus = ["accettazione","avvenuta-consegna","presa-in-carico","posta-certificata"];
  
  var stringBundle;
  var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);  

  
  pub.jsdump = function(str){
    if(prefTP.getDebug()){
      Components.classes['@mozilla.org/consoleservice;1']
                .getService(Components.interfaces.nsIConsoleService)
                .logStringMessage("ThunderPEC: "+str);
                }
  }
  
  xmlReader.contentHandler = {
    startDocument: function() {
      attrs = new Array();
      getChar = false; 
      getValue = ""; 
      dstAddr = 0;
      org.xtc.tp.search.jsdump("start XML document processing");
    },
    endDocument: function() {
        org.xtc.tp.search.jsdump("stop XML document processing");
    },
    startElement: function(uri, localName, qName, attributes) {
      getChar = true;
      getValue = qName;
      if(!(getValue in attrs)){
        attrs[getValue] = new Array();
        }    
      if(getValue.toLowerCase()=="destinatari") {
        attrs[getValue][dstAddr] = new Array();
        attrsArray = attrs[getValue][dstAddr];
      } else {
        attrsArray = attrs[getValue];
      }
      attrsArray["_value"] = "";
      for(var i=0; i<attributes.length; i++) {
        attrsArray[attributes.getQName(i)]=attributes.getValue(i);
      }
    },
    endElement: function(uri, localName, qName) {
      getChar = false;
      getValue = "";
      if(qName.toLowerCase()=="destinatari") {
        dstAddr++;
      }
    },
    characters: function(value) {
      if(getChar)attrsArray["_value"] +=value;
    },
    processingInstruction: function(target, data) {
    },
    ignorableWhitespace: function(whitespace) {
    },
    startPrefixMapping: function(prefix, uri) {
    },
    endPrefixMapping: function(prefix) {
    },
    QueryInterface: function(iid) {
      if(!iid.equals(Components.interfaces.nsISupports) &&
         !iid.equals(Components.interfaces.nsISAXContentHandler))
        throw Components.results.NS_ERROR_NO_INTERFACE;
      return this;
    }
  }

  pub.init = function(){
    var xmlstring;

    stringBundle = document.getElementById("tpecStringBundle");

    if("arguments" in window && window.arguments.length > 0) {
      xmlstring = window.arguments[0].xml;
      tmpDir = window.arguments[0].dir;
      folder = window.arguments[0].fld;
    }
    searchPrefs =  Components.classes["@mozilla.org/preferences-service;1"]
      .getService(Components.interfaces.nsIPrefBranch);
    searchPrefs.setCharPref("mailnews.customHeaders", tpecArrayHdrs.join(": "));

    messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();
    messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);

    prefTP = new ThunderPecPrefs();
    prefTP.init();
    
    document.getElementById("tpecReadButton").setAttribute('disabled', true);
    char12 = 12;
    char10 = 10;    
    
    xmlDoc = xmlstring;
    this.doSearch();
  }


  pub.ok = function(){
    window.close();
  }

  pub.legend = function(){
    showLegend = !showLegend;
    org.xtc.tp.search.refresh();
  }

  pub.print = function(){
    var receipt = document.getElementById("tpecSearchViewer");
    receipt.contentWindow.print();
  }
  
  var tpecSearchListener = {
    onSearchHit: function(dbHdr, folder){ 
      if(searchCycle==0){
        tpecSentHdr = dbHdr;
        org.xtc.tp.search.jsdump("found sent message with id : "+msgId); 
        try {
          MsgHdrToMimeMessage(dbHdr, null, function(aMsgHdr, aMimeMsg) {
            if(aMimeMsg == null)return;
            sentAttachments = aMimeMsg.allAttachments;  
            sentAttachments = sentAttachments.filter(function (x) x.isRealAttachment);  
            [sentSnippet, sentMeta] = mimeMsgToContentSnippetAndMeta(aMimeMsg,aMsgHdr.folder,300);
            if(sentSnippet.length==0)sentSnippet = "[empty body]"
            },true);

        } catch (e if e.result == Components.results.NS_ERROR_FAILURE) {
          sentSnippet = "...";
        }
      } else {
        tpecNotificationsHdr.push(dbHdr);
        org.xtc.tp.search.jsdump("found notification message with id : "+msgId); 
      }
    },
    onSearchDone: function(status){
      if(searchCycle==0){
        searchSession = null;
        searchSession = Components.classes["@mozilla.org/messenger/searchSession;1"]
          .createInstance(Components.interfaces.nsIMsgSearchSession);
        searchSession.addScopeTerm(Components.interfaces.nsMsgSearchScope.offlineMail, folder);
        org.xtc.tp.search.tpecSubFolders(folder, searchSession);
        searchCycle = 1;
        
        var searchTerm = searchSession.createTerm();
        var value = searchTerm.value;
        searchTerm.attrib = tpecFirstHeader+1;
        value.str = msgId;
        value.attrib =  tpecFirstHeader+1;
        searchTerm.arbitraryHeader = tpecArrayHdrs[tpecFirstHeader+1 - 1 - Components.interfaces.nsMsgSearchAttrib.OtherHeader];
        searchTerm.value = value;
        searchTerm.op = tpecContains;
        searchTerm.booleanAnd = false;
        
        searchSession.appendTerm(searchTerm);
        searchSession.registerListener(tpecSearchListener);
        searchSession.search(null);         
        //org.xtc.tp.search.refresh();
      } else {
        //org.xtc.tp.search.refresh();
        if(tpecNotificationsHdr.length >0){
          tpecIdx = 0;
          org.xtc.tp.search.processNotifications();
        }
      }
    },
    onNewSearch: function(){
    }
  };

  pub.tpecSubFolders = function(folder, searchSession) {
    var subFolders = folder.subFolders;
    while (subFolders.hasMoreElements()) {
      var nextFolder = subFolders.getNext().QueryInterface(Components.interfaces.nsIMsgFolder);
      
      if (!(nextFolder.flags & Components.interfaces.nsMsgFolderFlags.Virtual)) {
          org.xtc.tp.search.jsdump("adding search folder : ("+nextFolder.name+")");
          searchSession.addScopeTerm(Components.interfaces.nsMsgSearchScope.offlineMail,nextFolder);
          org.xtc.tp.search.tpecSubFolders(nextFolder, searchSession);
      }
    }
  };
  
  pub.doSearch = function() {
    xmlReader.parseFromString(xmlDoc, "text/xml");
    //setting xmlSentHdr
    xmlSentHdr["from"] =  attrs["mittente"]["_value"];
    xmlSentHdr["subject"] = attrs["oggetto"]["_value"];
    var attrsArray = attrs["destinatari"];
    var toString = "";
    for(x in attrsArray){
      if(toString!="")toString += ",";
      toString += attrsArray[x]["_value"];
    } 
    xmlSentHdr["to"] = toString;
    
    msgId = attrs["msgid"]["_value"].replace(/<|>/gi,"");
    originalMsgId = msgId;
    //msgId = msgId.replace(/<|>/gi,"");
    
    searchSession = Components.classes["@mozilla.org/messenger/searchSession;1"]
      .createInstance(Components.interfaces.nsIMsgSearchSession);
    searchSession.addScopeTerm(Components.interfaces.nsMsgSearchScope.offlineMail, folder);
    org.xtc.tp.search.tpecSubFolders(folder, searchSession);
    searchCycle = 0;
    
    var searchTerm = searchSession.createTerm();
    var value = searchTerm.value;
    searchTerm.attrib = tpecFirstHeader;
    value.str = msgId;
    value.attrib =  tpecFirstHeader;
    searchTerm.arbitraryHeader = tpecArrayHdrs[tpecFirstHeader - 1 - Components.interfaces.nsMsgSearchAttrib.OtherHeader];
    searchTerm.value = value;
    searchTerm.op = tpecContains;
    searchTerm.booleanAnd = false;
    
    searchSession.appendTerm(searchTerm);
    searchSession.registerListener(tpecSearchListener);
    searchSession.search(null);    
    }
    
    pub.processNotifications = function() {
      var tmpHdr;
      if(tpecIdx<tpecNotificationsHdr.length){
        tmpHdr = tpecNotificationsHdr[tpecIdx];
        org.xtc.tp.search.jsdump("process XML notifications : ("+tpecIdx+") "+tmpHdr.subject);
        try {
          MsgHdrToMimeMessage(tmpHdr, null, function(aMsgHdr, aMimeMsg) {
            if(aMimeMsg == null)return;
            var attachs = aMimeMsg.allAttachments;
            var xmlAttach = null;
            for(x in attachs){
              if (attachs[x].contentType.toLowerCase()=="application/xml"){
                xmlAttach = attachs[x];
                break;
                }
            }
            if(xmlAttach!=null){
              var tmpfile = Components.classes["@mozilla.org/file/local;1"]
                .createInstance(Components.interfaces.nsILocalFile);
              tmpfile.initWithPath(tmpDir);
              tmpfile.append(xmlAttach.name);
              tmpfile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0600);
              messenger.saveAttachmentToFile(tmpfile,xmlAttach.url,aMsgHdr.folder.getUriForMsg(aMsgHdr),xmlAttach.contenType,{
                OnStartRunningUrl : function (url) {},
                OnStopRunningUrl : function (url,code) {
                  var xmldata = "";
                  var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].
                                createInstance(Components.interfaces.nsIFileInputStream);
                  var cstream = Components.classes["@mozilla.org/intl/converter-input-stream;1"].
                                createInstance(Components.interfaces.nsIConverterInputStream);
                  fstream.init(tmpfile, -1, 0, 0);
                  cstream.init(fstream, "UTF-8", 0, 0);
                  let (str = {}) {
                    let read = 0;
                    do { 
                      read = cstream.readString(0xffffffff, str); 
                      xmldata += str.value;
                    } while (read != 0);
                  }
                  cstream.close(); 
                  tmpfile.remove(true);
                  xmlReader.parseFromString(xmldata, "text/xml");
                  org.xtc.tp.search.processAttributes();
                  //org.xtc.tp.search.jsdump("xmldoc: "+attrs["consegna"]);
                  tpecIdx += 1;
                  org.xtc.tp.search.processNotifications();
                }
              });
            }
            });
        } catch (e if e.result == Components.results.NS_ERROR_FAILURE) {
          org.xtc.tp.search.jsdump("error in searchTP : "+e);
        }
        
      } else {
        org.xtc.tp.search.refresh();
      }
    }
 
    pub.processAttributes = function(){
        if(dstAttribute==null){
          dstAttribute = new Array();
          attrsArray = attrs["destinatari"];
          for(x in attrsArray){
            org.xtc.tp.search.jsdump("processing attribute: "+attrsArray[x]["_value"]);

            dstAttribute[attrsArray[x]["_value"]] = new Array();
            dstAttribute[attrsArray[x]["_value"]]["type"] = attrsArray[x]["tipo"];            
          }
        }
        //org.xtc.tp.search.jsdump("consegna erroreesteso: "+attrs["consegna"]["_value"]); 
        if("consegna" in attrs){
          dstAttribute[attrs["consegna"]["_value"]]["status"] = attrs["postacert"]["tipo"];  
          dstAttribute[attrs["consegna"]["_value"]]["error"] = attrs["postacert"]["errore"]; 
          //dstAttribute[attrs["consegna"]["_value"]]["error"] = (attrs["postacert"]["errore"]!="nessuno"?attrs["errore-esteso"]["_value"]:"nessuno"); 
          //org.xtc.tp.search.jsdump("erroreesteso: "+attrs["errore-esteso"]["_value"]); 
          dstAttribute[attrs["consegna"]["_value"]]["provider"] = attrs["gestore-emittente"]["_value"];
          dstAttribute[attrs["consegna"]["_value"]]["date"] = attrs["giorno"]["_value"]+" "+attrs["ora"]["_value"]+"(GMT "+attrs["data"]["zona"]+")";
        } else {
          if(msgAttribute==null){
            msgAttribute = new Array();
          }
          var tmpAttribute = new Array();
          tmpAttribute["status"] = attrs["postacert"]["tipo"];  
          tmpAttribute["error"] = attrs["postacert"]["error"];  
          tmpAttribute["provider"] = attrs["gestore-emittente"]["_value"];
          tmpAttribute["date"] = attrs["giorno"]["_value"]+" "+attrs["ora"]["_value"]+"(GMT "+attrs["data"]["zona"]+")";
          msgAttribute.push(tmpAttribute);
        }
    }    

    pub.renderSubject = function(subject){
      var result = org.xtc.tp.search.toHTML(subject);
      var subjectStatus;
      var bubbleStyle;
      
      for(x in msgAttribute){
        subjectStatus = (("status" in msgAttribute[x])&&(typeof msgAttribute[x]["status"] !== 'undefined')?msgAttribute[x]["status"]:"")
        if(subjectStatus!=""){
          subjectStatus = subjectStatus.replace(/ /gi,"");
          //org.xtc.tp.search.jsdump("renderSubject: "+clearStatus.join(",").indexOf(subjectStatus));
          if(clearStatus.join(",").indexOf(subjectStatus)==-1){
            bubbleStyle="redbubble";
          } else{ 
            bubbleStyle="bluebubble";
            }
          result += "&nbsp;<font class=\""+bubbleStyle+"\">&nbsp;["+translateStatus[subjectStatus]+"]&nbsp;</font>"
        }
      }
      return result;
    }

    pub.renderAddresses = function(addresses,withbr){
      var result = "";
      var addressArray;
      var addressStatus;
      var bubbleStyle;
      var singleAddress;
      var realAddress;
      var spc;
      
      addressArray = addresses.split(",");
      spc = (withbr?"<br/>":"&nbsp;");
      for (var a=0;a<addressArray.length;a++){
        if(result!="")result += ","+spc;
        
        singleAddress = addressArray[a];
        if(singleAddress.indexOf("<")!=-1){
          realAddress = singleAddress.substring(
             singleAddress.indexOf("<")+1,
             singleAddress.indexOf(">")
          );
        } else {
        realAddress = singleAddress;
        }
        realAddress =  realAddress.replace(/ /gi,"");
        addressStatus = (("status" in dstAttribute[realAddress])&&(typeof dstAttribute[realAddress]["status"] !== 'undefined')?dstAttribute[realAddress]["status"]:"")
        //org.xtc.tp.search.jsdump("renderAddresses: "+addressStatus);
        if(addressStatus!=""){
          if(clearStatus.join(",").indexOf(addressStatus)==-1){
            bubbleStyle="redbubble";
          } else{ 
            bubbleStyle="bluebubble";
            }
          result += org.xtc.tp.search.toHTML(singleAddress)+"&nbsp;<font class=\""+bubbleStyle+"\">&nbsp;["+translateStatus[addressStatus]+"]&nbsp;</font>";
        } else {
          result += org.xtc.tp.search.toHTML(singleAddress);
        }
      }
      //org.xtc.tp.search.jsdump("renderAddresses: "+result);
      return result;
    }
    
    pub.refresh = function(){
      htmlDoc = "";
      htmlDoc += "<html>\n";
      htmlDoc += "<head>\n";
      htmlDoc += "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
      htmlDoc += "<style type=\"text/css\">\n";
      htmlDoc += "<!--\n";
      htmlDoc += ".desc {font-size:14px;font-weight:bold;}\n";
      htmlDoc += ".value {font-size:14px;font-weight:normal;}\n";
      htmlDoc += ".valuec {font-size:14px;font-weight:normal;text-transform:capitalize;}\n";
      htmlDoc += ".redline {height:2px;background:#E52B50;padding:0px;}\n";
      htmlDoc += ".blueline {height:2px;background:#6495ED;padding:0px;}\n";
      htmlDoc += "table.maintable {border-width:2px;border-spacing:0px;border-style:solid;border-color:black;border-collapse:separate;background-color:#f0f0f0;;}\n";
      htmlDoc += "table.maintable th {border-width:1px;padding:0px;border-style:solid;border-color:black;background-color:#f0f0f0;}\n";
      htmlDoc += "table.maintable td {border-width:1px;padding:0px;border-style:solid;border-color:black;background-color:#f0f0f0;}\n";
      htmlDoc += "table.headertable {border-width:0px 0px 5px 0px;border-spacing:0px;border-style:ridge;border-color:gray;border-collapse:collapse;background-color:#f0f0f0;}\n";
      htmlDoc += "table.headertable th {border-width:0px;background-color:#f0f0f0;}\n";
      htmlDoc += "table.headertable td {border-width:0px;background-color:#f0f0f0;}\n";
      htmlDoc += ".headernames {text-align:right;font-size:"+char12+"px;font-weight:normal;color:rgb(136, 138, 133);}\n";
      htmlDoc += ".headervalues {text-align:left;font-size:"+char12+"px;font-weight:normal;}\n";
      htmlDoc += ".headervaluesbold {text-align:left;font-size:"+char12+"px;font-weight:bold;}\n";
      htmlDoc += "table.bodytable {border-width:0px;background-color:white;}\n";
      htmlDoc += "table.bodytable th {border-width:0px;background-color:white;}\n";
      htmlDoc += "table.bodytable td {border-width:0px;background-color:white;}\n";
      htmlDoc += ".bodytext {text-align:left;font-size:"+char10+"px;font-weight:normal;}\n";
      htmlDoc += "table.attachtable {border-width:0px;background-color:white;}\n";
      htmlDoc += "table.attachtable th {border-width:0px;background-color:white;}\n";
      htmlDoc += "table.attachtable td {border-width:0px;background-color:white;}\n";
      htmlDoc += ".attachtext {text-align:left;font-size:"+char10+"px;font-weight:normal;}\n";
      htmlDoc += "table.notificationtable {border-width:0px;background-color:white;;}\n";
      htmlDoc += "table.notificationtable th {border-width:1px;border-style: outset;border-color: black;background-color:#f0f0f0;}\n";
      htmlDoc += "table.notificationtable td {border-width:1px;border-style: outset;border-color: black;background-color:white;}\n";
      htmlDoc += ".notificationtext {text-align:center;font-size:"+char10+"px;font-weight:normal;}\n";
      htmlDoc += ".notificationhdr {text-align:center;font-size:"+char10+"px;font-weight:bold;}\n";
      htmlDoc += "table.legendtable {border-width:0px;background-color:white;;}\n";
      htmlDoc += "table.legendntable th {border-width:0px;border-style: outset;border-color: black;background-color:#f0f0f0;}\n";
      htmlDoc += "table.legendtable td {border-width:0px;border-style: outset;border-color: black;background-color:white;}\n";
      htmlDoc += ".legendtext {text-align:center;font-size:"+char10+"px;font-weight:normal;}\n";
      htmlDoc += ".redbubble {text-align:center;font-size:"+char12+"px;font-weight:bold;background-color:#ff0000;-moz-border-radius:5px;color:white;}\n";
      htmlDoc += ".bluebubble {text-align:center;font-size:"+char12+"px;font-weight:bold;background-color:#0000ff;-moz-border-radius:5px;color:white;}\n";
      htmlDoc += "-->\n";
      htmlDoc += "</style>\n";
      htmlDoc += "</head>\n";
      htmlDoc += "<body>\n";
      htmlDoc += "<table class=\"maintable\" width=\"100%\">\n";
	    htmlDoc += "<tr><td>\n";
	    if(showLegend){
        htmlDoc += "<table class=\"legendtable\" width=\"100%\">\n";
  	    //htmlDoc += "<tr><td colspan=\"2\" align=\"center\" class=\"legendtext\"><font class=\"bluebubble\">&nbsp;Normale&nbsp;</font>&nbsp;notifica normale&nbsp;</td><td colspan=\"2\" align=\"center\" class=\"legendtext\"><font class=\"redbubble\">&nbsp;Errore&nbsp;</font>&nbsp;notifica di errore&nbsp;</td></tr>\n";
        var oddLegend = 1;
        var bubbleLegend;
        for(x in translateStatus){
          if(clearStatus.join(",").indexOf(x)==-1){
            bubbleLegend = "redbubble";
          } else {
            bubbleLegend = "bluebubble";
          }
          if(oddLegend==1){
            htmlDoc +=  "<tr><td class=\"legendtext\"><font class=\""+bubbleLegend+"\">&nbsp;["+translateStatus[x]+"]&nbsp;</font>&nbsp;=&nbsp;"+x+"</td>\n";
          } else if(oddLegend==4){
            htmlDoc +=  "<td class=\"legendtext\"><font class=\""+bubbleLegend+"\">&nbsp;["+translateStatus[x]+"]&nbsp;</font>&nbsp;=&nbsp;"+x+"</td></tr>\n";
          } else {
            htmlDoc +=  "<td class=\"legendtext\"><font class=\""+bubbleLegend+"\">&nbsp;["+translateStatus[x]+"]&nbsp;</font>&nbsp;=&nbsp;"+x+"</td>\n";                
          }
          oddLegend = (oddLegend==4?1:oddLegend+1);
        }
        htmlDoc += "</table>\n";       
        htmlDoc += "<tr><td>\n";
      }
	    if(tpecSentHdr!=null){
        htmlDoc += "<table class=\"headertable\" width=\"100%\" align=\"left\">\n";
  	    htmlDoc += "<tr><td class=\"headernames\" width=\"10%\">da:&nbsp;&nbsp;</td><td class=\"headervalues\">"+org.xtc.tp.search.toHTML(tpecSentHdr.author)+"</td></tr>\n";
  	    //htmlDoc += "<tr><td class=\"headernames\" width=\"10%\">oggetto:&nbsp;&nbsp;</td><td class=\"headervaluesbold\">"+org.xtc.tp.search.renderSubject(tpecSentHdr.subject)+"</td></tr>\n";
  	    htmlDoc += "<tr><td class=\"headernames\" width=\"10%\">oggetto:&nbsp;&nbsp;</td><td class=\"headervaluesbold\">"+org.xtc.tp.search.renderSubject(xmlSentHdr["subject"])+"</td></tr>\n";
  	    htmlDoc += "<tr><td class=\"headernames\" width=\"10%\">a:&nbsp;&nbsp;</td><td class=\"headervalues\">"+org.xtc.tp.search.renderAddresses(tpecSentHdr.recipients,false)+"</td></tr>\n";
  	    if(tpecSentHdr.ccList!=""){
          htmlDoc += "<tr><td class=\"headernames\">cc:&nbsp;&nbsp;</td><td class=\"headervalues\">"+org.xtc.tp.search.renderAddresses(tpecSentHdr.ccList,false)+"</td></tr>\n";
        }
        var msgDate = new Date(tpecSentHdr.date/1000);
  	    htmlDoc += "<tr><td class=\"headernames\" width=\"10%\">inviato:&nbsp;&nbsp;</td><td class=\"headervalues\">"+org.xtc.tp.search.toHTML(msgDate.toLocaleString())+"</td></tr>\n";
  	    htmlDoc += "<tr><td class=\"headernames\" width=\"10%\">msg id:&nbsp;&nbsp;</td><td class=\"headervalues\">"+originalMsgId+"</td></tr>\n";
        htmlDoc += "</table>\n";       
  	    if(sentSnippet!=""){
          htmlDoc += "<table class=\"bodytable\" width=\"100%\">\n";
          htmlDoc += "<tr><td><pre class=\"bodytext\">"+org.xtc.tp.search.toHTML(sentSnippet)+"</pre></td></tr>\n";
          htmlDoc += "</table>\n";       
        }
        if((sentAttachments!=null)&&(sentAttachments.length>0)){
          htmlDoc += "<table class=\"attachtable\" width=\"100%\">\n";
          htmlDoc += "<tr><td colspan=\"2\" class=\"bodytext\"><hr/></td></tr>\n";       
          htmlDoc += "<tr><td class=\"bodytext\"><b>Allegati</b></td><td></td></tr>\n";
          var oddNumber = true;
          for(x in sentAttachments){
                if(oddNumber){
                  htmlDoc +=  "<tr><td class=\"attachtext\">"+sentAttachments[x].name+"</td>";
                } else {
                  htmlDoc +=  "<td class=\"attachtext\">"+sentAttachments[x].name+"</td></tr>\n";                
                }
                oddNumber = !oddNumber;
          }
          if(!oddNumber)htmlDoc +=  "<td></td></tr>\n";
          htmlDoc += "</table>\n";       
          
        }
      } else {
        htmlDoc += "<table class=\"headertable\" width=\"100%\" align=\"left\">\n";
  	    htmlDoc += "<tr><td class=\"headernames\" width=\"10%\">da:&nbsp;&nbsp;</td><td class=\"headervalues\">"+xmlSentHdr["from"]+"</td></tr>\n";
  	    htmlDoc += "<tr><td class=\"headernames\" width=\"10%\">oggetto:&nbsp;&nbsp;</td><td class=\"headervaluesbold\">"+org.xtc.tp.search.renderSubject(xmlSentHdr["subject"])+"</td></tr>\n";
  	    htmlDoc += "<tr><td class=\"headernames\" width=\"10%\" valign=\"top\">a/cc:&nbsp;&nbsp;</td><td class=\"headervalues\">"+org.xtc.tp.search.renderAddresses(xmlSentHdr["to"],true)+"</td></tr>\n";      
  	    htmlDoc += "<tr><td class=\"headernames\" width=\"10%\">msg id:&nbsp;&nbsp;</td><td class=\"headervalues\">"+originalMsgId+"</td></tr>\n";
        htmlDoc += "</table>\n";       
      }
      htmlDoc += "</td></tr>\n";
	    htmlDoc += "<tr><td>\n";
	    if(msgAttribute!=null){
          htmlDoc += "<table class=\"notificationtable\" width=\"100%\">\n";
          htmlDoc += "<tr><th colspan=\"4\" class=\"notificationhdr\">Stato del messaggio</th></tr>\n";
          htmlDoc += "<tr>";
          htmlDoc += "<td class=\"notificationhdr\">Stato</td>";            
          htmlDoc += "<td class=\"notificationhdr\">Gestore PEC</td>";            
          htmlDoc += "<td class=\"notificationhdr\">Data</td>"; 
          htmlDoc += "<td class=\"notificationhdr\">Errore</td>";            
          htmlDoc += "</tr>\n";
          for(x in msgAttribute){
            htmlDoc += "<tr>";
            htmlDoc += "<td class=\"notificationtext\">"+(("status" in msgAttribute[x])&&(typeof msgAttribute[x]["status"] !== 'undefined')?msgAttribute[x]["status"]:"&nbsp;")+"</td>";            
            htmlDoc += "<td class=\"notificationtext\">"+(("provider" in msgAttribute[x])&&(typeof msgAttribute[x]["provider"] !== 'undefined')?msgAttribute[x]["provider"]:"&nbsp;")+"</td>";            
            htmlDoc += "<td class=\"notificationtext\">"+(("date" in msgAttribute[x])&&(typeof msgAttribute[x]["date"] !== 'undefined')?msgAttribute[x]["date"]:"&nbsp;")+"</td>"; 
            htmlDoc += "<td class=\"notificationtext\">"+(("error" in msgAttribute[x])&&(typeof msgAttribute[x]["error"] !== 'undefined')?msgAttribute[x]["error"]:"&nbsp;")+"</td>";            
            htmlDoc += "</tr>\n";
          }
          htmlDoc += "</table>\n";       
      }	    
	    if(dstAttribute!=null){
          htmlDoc += "<table class=\"notificationtable\" width=\"100%\">\n";
          htmlDoc += "<tr><th colspan=\"6\" class=\"notificationhdr\">Stato dei destinatari</th></tr>\n";
          htmlDoc += "<tr>";
          htmlDoc += "<td class=\"notificationhdr\">Destinatario</td>";
          htmlDoc += "<td class=\"notificationhdr\">Tipo</td>";
          htmlDoc += "<td class=\"notificationhdr\">Stato</td>";            
          htmlDoc += "<td class=\"notificationhdr\">Gestore PEC</td>";            
          htmlDoc += "<td class=\"notificationhdr\">Data</td>"; 
          htmlDoc += "<td class=\"notificationhdr\">Errore</td>";            
          htmlDoc += "</tr>\n";
          for(x in dstAttribute){
            htmlDoc += "<tr>";
            htmlDoc += "<td class=\"notificationtext\">"+x+"</td>";
            htmlDoc += "<td class=\"notificationtext\">"+dstAttribute[x]["type"]+"</td>";
            htmlDoc += "<td class=\"notificationtext\">"+(("status" in dstAttribute[x])&&(typeof dstAttribute[x]["status"] !== 'undefined')?dstAttribute[x]["status"]:"&nbsp;")+"</td>";            
            htmlDoc += "<td class=\"notificationtext\">"+(("provider" in dstAttribute[x])&&(typeof dstAttribute[x]["provider"] !== 'undefined')?dstAttribute[x]["provider"]:"&nbsp;")+"</td>";            
            htmlDoc += "<td class=\"notificationtext\">"+(("date" in dstAttribute[x])&&(typeof dstAttribute[x]["date"] !== 'undefined')?dstAttribute[x]["date"]:"&nbsp;")+"</td>"; 
            htmlDoc += "<td class=\"notificationtext\">"+(("error" in dstAttribute[x])&&(typeof dstAttribute[x]["error"] !== 'undefined')?dstAttribute[x]["error"]:"&nbsp;")+"</td>";            
            htmlDoc += "</tr>\n";
          }
          htmlDoc += "</table>\n";       
      }	    
      htmlDoc += "</td></tr>\n";
      htmlDoc += "</table>\n";
      htmlDoc += "</body>\n";
      htmlDoc += "</html>\n";

      //org.xtc.tp.search.jsdump("msgID: "+msgId);    
      var filename = "search.html";
      var xmlfile = Components.classes["@mozilla.org/file/local;1"]
        .createInstance(Components.interfaces.nsILocalFile);
      xmlfile.initWithPath(tmpDir);
      xmlfile.append(filename);
      var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
                               createInstance(Components.interfaces.nsIFileOutputStream);
      foStream.init(xmlfile, 0x02 | 0x08 | 0x20, 0600, 0); 
      //foStream.write(htmlDoc, htmlDoc.length);
      //foStream.close();
      var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
          createInstance(Components.interfaces.nsIConverterOutputStream);
      converter.init(foStream, "UTF-8", 0, 0);
      converter.writeString(htmlDoc);
      converter.close(); 
      var ios = Components.classes["@mozilla.org/network/io-service;1"].
                  getService(Components.interfaces.nsIIOService);
      var url = ios.newFileURI(xmlfile);
      
      var timestamp = new Date().getTime();      
      document.getElementById("tpecSearchViewer").setAttribute('src', url.spec+"?t="+timestamp);
      document.getElementById("tpecReadButton").setAttribute('disabled', false);        
    };

    pub.toHTML = function(s){
      var result = s;
      //result = result.replace(/</gi,"&lt;");
      //result = result.replace(/>/gi,"&gt;");
      result = ThunderPecUtility.escapeHtmlEntities(result);
      return result;
      }
      
    pub.markread = function(){
        for(var i = 0;i<tpecNotificationsHdr.length;i++){
          tpecNotificationsHdr[i].markRead(true);
        }    
    }
    pub.charUp = function(){
        if(char12<20){
          char12++;
          char10++;
          org.xtc.tp.search.refresh();
        }   
    }
    pub.charDown = function(){
        if(char12>12){
          char12--;
          char10--;
          org.xtc.tp.search.refresh();
        }   
    }
  
  
    pub.archive = function() {
    
      document.getElementById("tpecArchiveButton").setAttribute('disabled', true);      
      var suffix = new Date().toISOString().replace(new RegExp("[-:.]","g"),"");
      var filezip;

      var nsIFilePicker = Components.interfaces.nsIFilePicker;
      var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
      fp.init(window, stringBundle.getString('tpec.search.save'), nsIFilePicker.modeSave);
      fp.appendFilter("File ZIP","*.zip");
      fp.defaultExtension = ".zip";
      fp.defaultString = suffix+".zip";
      
      var rv = fp.show();
      if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
        org.xtc.tp.search.jsdump(fp.file+" "+fp.file.path);
       
        try {
          var zipWriter = Components.Constructor("@mozilla.org/zipwriter;1", "nsIZipWriter");
          var zipW = new zipWriter();
          zipW.open(fp.file, PR_RDWR | PR_CREATE_FILE | PR_TRUNCATE);
   
          var htmlfile = Components.classes["@mozilla.org/file/local;1"]
            .createInstance(Components.interfaces.nsILocalFile);
          htmlfile.initWithPath(tmpDir);
          htmlfile.append(suffix+"-report.html");
          if(!htmlfile.exists()){
            var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
                                     createInstance(Components.interfaces.nsIFileOutputStream);
            foStream.init(htmlfile, 0x02 | 0x08 | 0x20, 0600, 0); 
            foStream.write(htmlDoc,htmlDoc.length);
            foStream.close();
            zipW.addEntryFile(htmlfile.leafName, Components.interfaces.nsIZipWriter.COMPRESSION_DEFAULT, htmlfile, false);
          }

          var msgArray = new Array();
          
          var uri;
          if(tpecSentHdr){
            filename = suffix+"-00-messaggio.eml";
            uri = tpecSentHdr.folder.getUriForMsg(tpecSentHdr);
            msgArray.push([filename,uri]);
          }
          
          var tmpHdr;
          var count = 1;
          var subject;
          var colon;
          for(var tpecIdx=0;tpecIdx<tpecNotificationsHdr.length;tpecIdx++){
            tmpHdr = tpecNotificationsHdr[tpecIdx];
            filename = suffix+"-"+(count<9?"0"+count:count);
            count++;
            uri = tmpHdr.folder.getUriForMsg(tmpHdr);
            subject = tmpHdr.mime2DecodedSubject.toLowerCase();
            colon = subject.indexOf(':');
            subject = subject.substring(0,colon).replace(/ /gi,"");
            filename += "-"+subject+".eml";
            msgArray.push([filename,uri]);
           }
           
           org.xtc.tp.search.asyncSaveToFile(msgArray,tmpDir,0,zipW,fp.file.path);
   
        } catch(e){
          prompts.alert(window,stringBundle.getString('tpec.error'),stringBundle.getString('tpec.error.savezip')+" "+fp.file.path)        
          document.getElementById("tpecArchiveButton").setAttribute('disabled', false);    
        }
      }  

    };

  pub.asyncSaveToFile = function(auri,path,idx,zip,fzip) {
      var streamListener = {
        foStream : null,
        chkfile : null,
        QueryInterface : function(iid)  {
                if (iid.equals(Components.interfaces.nsIStreamListener) ||  
                    iid.equals(Components.interfaces.nsISupports))
                return this;
                throw Components.results.NS_NOINTERFACE;
                return 0;
        },
        onStartRequest : function (aRequest, aContext) {
          if(idx<auri.length){
            chkfile = Components.classes["@mozilla.org/file/local;1"]
              .createInstance(Components.interfaces.nsILocalFile);
            chkfile.initWithPath(path);
            chkfile.append(auri[idx][0]);
            org.xtc.tp.search.jsdump("OK: START saving message "+auri[idx][0]);
            foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
                                     createInstance(Components.interfaces.nsIFileOutputStream);
            foStream.init(chkfile, 0x02 | 0x08 | 0x20, 0600, 0); 
          }
        },
        onStopRequest : function (aRequest, aContext, aStatusCode) {
          if(idx<auri.length){
            foStream.close();
            foStream = null;
            org.xtc.tp.search.jsdump("OK: END saving message "+auri[idx][0]);
            zip.addEntryFile(chkfile.leafName, Components.interfaces.nsIZipWriter.COMPRESSION_DEFAULT, chkfile, false);
            idx++;
            if(idx<auri.length){
              org.xtc.tp.search.asyncSaveToFile(auri,path,idx,zip,fzip);  
            } else {
              zip.close();
              prompts.alert(window,stringBundle.getString('tpec.search.operationdone'),fzip+" "+stringBundle.getString('tpec.search.filesaved'))
              document.getElementById("tpecArchiveButton").setAttribute('disabled', false);    
            }
          }
        },
        onDataAvailable : function (aRequest, aContext, aInputStream, aOffset, aCount) {
      		var stream = Components.classes["@mozilla.org/scriptableinputstream;1"].
                           createInstance().QueryInterface(Components.interfaces.nsIScriptableInputStream);
      		stream.init(aInputStream);
          foStream.write(stream.read(aCount),aCount);
        }
      };
	var messageService = messenger.messageServiceFromURI(auri[idx][1]).QueryInterface(Components.interfaces.nsIMsgMessageService);
	messageService.streamMessage(auri[idx][1], streamListener, null, null, false, null);
  };      
      
  return pub;
}();
